function! TranslateSelectedText()
    let selection_mode = visualmode()

    let l:translated_text = ""

    if selection_mode == 'v' || selection_mode == 'V'
        " zeichen- oder linienweise Auswahl
        let l:current_text = getreg('"')
        let l:translated_text = system(g:translateit_path . '/translateit ' . shellescape(l:current_text, 1))
    elseif selection_mode == "\<C-V>"
        " blockweise Auswahl
        let l:current_text = getreg("x")
        let l:translated_text = system(g:translateit_path . '/translateit ' . shellescape(l:current_text, 1))
    end

    if l:translated_text != ""
        normal! gv
        normal! c
        execute 'normal! a' . l:translated_text
    endif
endfunction

